/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
  Pseudo_QC_All.qpp

  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/SingleValueIterator.h>
/* Qore class Qore::<value> */

qore_classid_t CID_PSEUDOVALUE;
QoreClass* QC_PSEUDOVALUE;

// bool PseudoValue::callp(){}
static bool PseudoValue_callp(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 183 "Pseudo_QC_All.qpp"
return false;
}

// bool PseudoValue::empty(){}
static bool PseudoValue_empty(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 89 "Pseudo_QC_All.qpp"
return true;
}

// bool PseudoValue::intp(){}
static bool PseudoValue_intp(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 155 "Pseudo_QC_All.qpp"
return false;
}

// AbstractIterator PseudoValue::iterator(){}
static QoreObject* PseudoValue_iterator(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 271 "Pseudo_QC_All.qpp"
return new QoreObject(QC_SINGLEVALUEITERATOR, 0, new SingleValueIterator(n));
}

// int PseudoValue::lsize(){}
static int64 PseudoValue_lsize(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 199 "Pseudo_QC_All.qpp"
return 1;
}

// int PseudoValue::size(){}
static int64 PseudoValue_size(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 110 "Pseudo_QC_All.qpp"
return 0;
}

// bool PseudoValue::sizep(){}
static bool PseudoValue_sizep(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 282 "Pseudo_QC_All.qpp"
return false;
}

// bool PseudoValue::strp(){}
static bool PseudoValue_strp(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 169 "Pseudo_QC_All.qpp"
return false;
}

// bool PseudoValue::toBool(){}
static bool PseudoValue_toBool(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 246 "Pseudo_QC_All.qpp"
return n ? n->getAsBool() : false;
}

// float PseudoValue::toFloat(){}
static double PseudoValue_toFloat(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 235 "Pseudo_QC_All.qpp"
return n ? n->getAsFloat() : 0.0;
}

// int PseudoValue::toInt(){}
static int64 PseudoValue_toInt(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 224 "Pseudo_QC_All.qpp"
return n ? n->getAsBigInt() : 0;
}

// number PseudoValue::toNumber(){}
static AbstractQoreNode* PseudoValue_toNumber(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 257 "Pseudo_QC_All.qpp"
return QoreNumberNode::toNumber(n);
}

// string PseudoValue::toString(){}
static AbstractQoreNode* PseudoValue_toString(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 212 "Pseudo_QC_All.qpp"
QoreStringNodeValueHelper str(n);
   return str.getReferencedValue();
}

// string PseudoValue::type(){}
static AbstractQoreNode* PseudoValue_type(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 70 "Pseudo_QC_All.qpp"
return new QoreStringNode(n ? n->getTypeName() : "nothing");
}

// int PseudoValue::typeCode(){}
static int64 PseudoValue_typeCode(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 55 "Pseudo_QC_All.qpp"
return get_node_type(n);
}

// bool PseudoValue::val(){}
static bool PseudoValue_val(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 139 "Pseudo_QC_All.qpp"
return false;
}

DLLLOCAL QoreClass* initPseudoValueClass() {
   QC_PSEUDOVALUE = new QoreClass("<value>", QDOM_DEFAULT);
   CID_PSEUDOVALUE = QC_PSEUDOVALUE->getID();

   // bool PseudoValue::callp(){}
   QC_PSEUDOVALUE->addMethodExtended3("callp", (q_method_bool_t)PseudoValue_callp, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // bool PseudoValue::empty(){}
   QC_PSEUDOVALUE->addMethodExtended3("empty", (q_method_bool_t)PseudoValue_empty, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // bool PseudoValue::intp(){}
   QC_PSEUDOVALUE->addMethodExtended3("intp", (q_method_bool_t)PseudoValue_intp, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // AbstractIterator PseudoValue::iterator(){}
   QC_PSEUDOVALUE->addMethodExtended3("iterator", (q_method_t)PseudoValue_iterator, false, QC_CONSTANT, QDOM_DEFAULT, QC_ABSTRACTITERATOR->getTypeInfo());

   // int PseudoValue::lsize(){}
   QC_PSEUDOVALUE->addMethodExtended3("lsize", (q_method_int64_t)PseudoValue_lsize, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   // int PseudoValue::size(){}
   QC_PSEUDOVALUE->addMethodExtended3("size", (q_method_int64_t)PseudoValue_size, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   // bool PseudoValue::sizep(){}
   QC_PSEUDOVALUE->addMethodExtended3("sizep", (q_method_bool_t)PseudoValue_sizep, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // bool PseudoValue::strp(){}
   QC_PSEUDOVALUE->addMethodExtended3("strp", (q_method_bool_t)PseudoValue_strp, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // bool PseudoValue::toBool(){}
   QC_PSEUDOVALUE->addMethodExtended3("toBool", (q_method_bool_t)PseudoValue_toBool, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // float PseudoValue::toFloat(){}
   QC_PSEUDOVALUE->addMethodExtended3("toFloat", (q_method_double_t)PseudoValue_toFloat, false, QC_CONSTANT, QDOM_DEFAULT, floatTypeInfo);

   // int PseudoValue::toInt(){}
   QC_PSEUDOVALUE->addMethodExtended3("toInt", (q_method_int64_t)PseudoValue_toInt, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   // number PseudoValue::toNumber(){}
   QC_PSEUDOVALUE->addMethodExtended3("toNumber", (q_method_t)PseudoValue_toNumber, false, QC_CONSTANT, QDOM_DEFAULT, numberTypeInfo);

   // string PseudoValue::toString(){}
   QC_PSEUDOVALUE->addMethodExtended3("toString", (q_method_t)PseudoValue_toString, false, QC_CONSTANT, QDOM_DEFAULT, stringTypeInfo);

   // string PseudoValue::type(){}
   QC_PSEUDOVALUE->addMethodExtended3("type", (q_method_t)PseudoValue_type, false, QC_CONSTANT, QDOM_DEFAULT, stringTypeInfo);

   // int PseudoValue::typeCode(){}
   QC_PSEUDOVALUE->addMethodExtended3("typeCode", (q_method_int64_t)PseudoValue_typeCode, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   // bool PseudoValue::val(){}
   QC_PSEUDOVALUE->addMethodExtended3("val", (q_method_bool_t)PseudoValue_val, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   return QC_PSEUDOVALUE;
}
