/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
  Pseudo_QC_Bool.qpp

  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
/* Qore class Qore::<bool> */

qore_classid_t CID_PSEUDOBOOL;
QoreClass* QC_PSEUDOBOOL;

// bool PseudoBool::intp(){}
static bool PseudoBool_intp(QoreObject* self, const QoreBoolNode* b, const QoreListNode* args, ExceptionSink* xsink) {
# 76 "Pseudo_QC_Bool.qpp"
return true;
}

// bool PseudoBool::strp(){}
static bool PseudoBool_strp(QoreObject* self, const QoreBoolNode* b, const QoreListNode* args, ExceptionSink* xsink) {
# 90 "Pseudo_QC_Bool.qpp"
return true;
}

// int PseudoBool::typeCode(){}
static int64 PseudoBool_typeCode(QoreObject* self, const QoreBoolNode* b, const QoreListNode* args, ExceptionSink* xsink) {
# 45 "Pseudo_QC_Bool.qpp"
return NT_BOOLEAN;
}

// bool PseudoBool::val(){}
static bool PseudoBool_val(QoreObject* self, const QoreBoolNode* b, const QoreListNode* args, ExceptionSink* xsink) {
# 62 "Pseudo_QC_Bool.qpp"
return (bool)b->getValue();
}

DLLLOCAL QoreClass* initPseudoBoolClass() {
   QC_PSEUDOBOOL = new QoreClass("<bool>", QDOM_DEFAULT);
   CID_PSEUDOBOOL = QC_PSEUDOBOOL->getID();

   // set parent class
   assert(QC_PSEUDOVALUE);
   QC_PSEUDOBOOL->addBuiltinVirtualBaseClass(QC_PSEUDOVALUE);

   // bool PseudoBool::intp(){}
   QC_PSEUDOBOOL->addMethodExtended3("intp", (q_method_bool_t)PseudoBool_intp, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // bool PseudoBool::strp(){}
   QC_PSEUDOBOOL->addMethodExtended3("strp", (q_method_bool_t)PseudoBool_strp, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // int PseudoBool::typeCode(){}
   QC_PSEUDOBOOL->addMethodExtended3("typeCode", (q_method_int64_t)PseudoBool_typeCode, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   // bool PseudoBool::val(){}
   QC_PSEUDOBOOL->addMethodExtended3("val", (q_method_bool_t)PseudoBool_val, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   return QC_PSEUDOBOOL;
}
