/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
  Pseudo_QC_callref.qpp

  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
/* Qore class Qore::<callref> */

qore_classid_t CID_PSEUDOCALLREF;
QoreClass* QC_PSEUDOCALLREF;

// bool PseudoCallref::callp(){}
static bool PseudoCallref_callp(QoreObject* self, const ResolvedCallReferenceNode* c, const QoreListNode* args, ExceptionSink* xsink) {
# 85 "Pseudo_QC_Callref.qpp"
return true;
}

// any PseudoCallref::exec(...){}
static AbstractQoreNode* PseudoCallref_exec_VV(QoreObject* self, const ResolvedCallReferenceNode* c, const QoreListNode* args, ExceptionSink* xsink) {
# 71 "Pseudo_QC_Callref.qpp"
c->exec(args, xsink);
   return 0;
}

// int PseudoCallref::typeCode(){}
static int64 PseudoCallref_typeCode(QoreObject* self, const ResolvedCallReferenceNode* c, const QoreListNode* args, ExceptionSink* xsink) {
# 45 "Pseudo_QC_Callref.qpp"
return NT_FUNCREF;
}

// bool PseudoCallref::val(){}
static bool PseudoCallref_val(QoreObject* self, const ResolvedCallReferenceNode* c, const QoreListNode* args, ExceptionSink* xsink) {
# 62 "Pseudo_QC_Callref.qpp"
return true;
}

DLLLOCAL QoreClass* initPseudoCallrefClass() {
   QC_PSEUDOCALLREF = new QoreClass("<callref>", QDOM_DEFAULT);
   CID_PSEUDOCALLREF = QC_PSEUDOCALLREF->getID();

   // set parent class
   assert(QC_PSEUDOVALUE);
   QC_PSEUDOCALLREF->addBuiltinVirtualBaseClass(QC_PSEUDOVALUE);

   // bool PseudoCallref::callp(){}
   QC_PSEUDOCALLREF->addMethodExtended3("callp", (q_method_bool_t)PseudoCallref_callp, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // any PseudoCallref::exec(...){}
   QC_PSEUDOCALLREF->addMethodExtended3("exec", (q_method_t)PseudoCallref_exec_VV, false, QC_USES_EXTRA_ARGS, QDOM_DEFAULT, anyTypeInfo);

   // int PseudoCallref::typeCode(){}
   QC_PSEUDOCALLREF->addMethodExtended3("typeCode", (q_method_int64_t)PseudoCallref_typeCode, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   // bool PseudoCallref::val(){}
   QC_PSEUDOCALLREF->addMethodExtended3("val", (q_method_bool_t)PseudoCallref_val, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   return QC_PSEUDOCALLREF;
}
