/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
  Pseudo_QC_closure.qpp

  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
/* Qore class Qore::<closure> */

qore_classid_t CID_PSEUDOCLOSURE;
QoreClass* QC_PSEUDOCLOSURE;

// int PseudoClosure::typeCode(){}
static int64 PseudoClosure_typeCode(QoreObject* self, const QoreClosureNode* c, const QoreListNode* args, ExceptionSink* xsink) {
# 45 "Pseudo_QC_Closure.qpp"
return NT_RUNTIME_CLOSURE;
}

DLLLOCAL QoreClass* initPseudoClosureClass() {
   QC_PSEUDOCLOSURE = new QoreClass("<closure>", QDOM_DEFAULT);
   CID_PSEUDOCLOSURE = QC_PSEUDOCLOSURE->getID();

   // set parent class
   assert(QC_PSEUDOCALLREF);
   QC_PSEUDOCLOSURE->addBuiltinVirtualBaseClass(QC_PSEUDOCALLREF);

   // int PseudoClosure::typeCode(){}
   QC_PSEUDOCLOSURE->addMethodExtended3("typeCode", (q_method_int64_t)PseudoClosure_typeCode, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   return QC_PSEUDOCLOSURE;
}
