/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
  Pseudo_QC_Nothing.qpp

  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
/* Qore class Qore::<nothing> */

qore_classid_t CID_PSEUDONOTHING;
QoreClass* QC_PSEUDONOTHING;

// SingleValueIterator PseudoNothing::contextIterator(){}
static QoreObject* PseudoNothing_contextIterator(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 107 "Pseudo_QC_Nothing.qpp"
return new QoreObject(QC_SINGLEVALUEITERATOR, 0, new SingleValueIterator(0));
}

// nothing PseudoNothing::firstKey(){}
static AbstractQoreNode* PseudoNothing_firstKey(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 161 "Pseudo_QC_Nothing.qpp"

   return 0;
}

// nothing PseudoNothing::firstValue(){}
static AbstractQoreNode* PseudoNothing_firstValue(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 178 "Pseudo_QC_Nothing.qpp"

   return 0;
}

// bool PseudoNothing::hasKey(softstring key){}
static bool PseudoNothing_hasKey_vs(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 231 "Pseudo_QC_Nothing.qpp"
return false;
}

// bool PseudoNothing::hasKeyValue(softstring key){}
static bool PseudoNothing_hasKeyValue_vs(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 251 "Pseudo_QC_Nothing.qpp"
return false;
}

// SingleValueIterator PseudoNothing::keyIterator(){}
static QoreObject* PseudoNothing_keyIterator(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 91 "Pseudo_QC_Nothing.qpp"
return new QoreObject(QC_SINGLEVALUEITERATOR, 0, new SingleValueIterator(0));
}

// list PseudoNothing::keys(){}
static AbstractQoreNode* PseudoNothing_keys(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 125 "Pseudo_QC_Nothing.qpp"
return new QoreListNode;
}

// nothing PseudoNothing::lastKey(){}
static AbstractQoreNode* PseudoNothing_lastKey(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 195 "Pseudo_QC_Nothing.qpp"

   return 0;
}

// nothing PseudoNothing::lastValue(){}
static AbstractQoreNode* PseudoNothing_lastValue(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 212 "Pseudo_QC_Nothing.qpp"

   return 0;
}

// int PseudoNothing::lsize(){}
static int64 PseudoNothing_lsize(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 61 "Pseudo_QC_Nothing.qpp"
return 0;
}

// SingleValueIterator PseudoNothing::pairIterator(){}
static QoreObject* PseudoNothing_pairIterator(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 75 "Pseudo_QC_Nothing.qpp"
return new QoreObject(QC_SINGLEVALUEITERATOR, 0, new SingleValueIterator(0));
}

// SingleValueIterator PseudoNothing::rangeIterator(){}
static QoreObject* PseudoNothing_rangeIterator(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 267 "Pseudo_QC_Nothing.qpp"
return new QoreObject(QC_SINGLEVALUEITERATOR, 0, new SingleValueIterator(0));
}

// int PseudoNothing::typeCode(){}
static int64 PseudoNothing_typeCode(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 45 "Pseudo_QC_Nothing.qpp"
return NT_NOTHING;
}

// list PseudoNothing::values(){}
static AbstractQoreNode* PseudoNothing_values(QoreObject* self, const AbstractQoreNode* n, const QoreListNode* args, ExceptionSink* xsink) {
# 143 "Pseudo_QC_Nothing.qpp"
return new QoreListNode;
}

DLLLOCAL QoreClass* initPseudoNothingClass() {
   QC_PSEUDONOTHING = new QoreClass("<nothing>", QDOM_DEFAULT);
   CID_PSEUDONOTHING = QC_PSEUDONOTHING->getID();

   // set parent class
   assert(QC_PSEUDOVALUE);
   QC_PSEUDONOTHING->addBuiltinVirtualBaseClass(QC_PSEUDOVALUE);

   // SingleValueIterator PseudoNothing::contextIterator(){}
   QC_PSEUDONOTHING->addMethodExtended3("contextIterator", (q_method_t)PseudoNothing_contextIterator, false, QC_CONSTANT, QDOM_DEFAULT, QC_SINGLEVALUEITERATOR->getTypeInfo());

   // nothing PseudoNothing::firstKey(){}
   QC_PSEUDONOTHING->addMethodExtended3("firstKey", (q_method_t)PseudoNothing_firstKey, false, QC_CONSTANT, QDOM_DEFAULT, nothingTypeInfo);

   // nothing PseudoNothing::firstValue(){}
   QC_PSEUDONOTHING->addMethodExtended3("firstValue", (q_method_t)PseudoNothing_firstValue, false, QC_CONSTANT, QDOM_DEFAULT, nothingTypeInfo);

   // bool PseudoNothing::hasKey(softstring key){}
   QC_PSEUDONOTHING->addMethodExtended3("hasKey", (q_method_bool_t)PseudoNothing_hasKey_vs, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo, 1, softStringTypeInfo, NULL, "key");

   // bool PseudoNothing::hasKeyValue(softstring key){}
   QC_PSEUDONOTHING->addMethodExtended3("hasKeyValue", (q_method_bool_t)PseudoNothing_hasKeyValue_vs, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo, 1, softStringTypeInfo, NULL, "key");

   // SingleValueIterator PseudoNothing::keyIterator(){}
   QC_PSEUDONOTHING->addMethodExtended3("keyIterator", (q_method_t)PseudoNothing_keyIterator, false, QC_CONSTANT, QDOM_DEFAULT, QC_SINGLEVALUEITERATOR->getTypeInfo());

   // list PseudoNothing::keys(){}
   QC_PSEUDONOTHING->addMethodExtended3("keys", (q_method_t)PseudoNothing_keys, false, QC_CONSTANT, QDOM_DEFAULT, listTypeInfo);

   // nothing PseudoNothing::lastKey(){}
   QC_PSEUDONOTHING->addMethodExtended3("lastKey", (q_method_t)PseudoNothing_lastKey, false, QC_CONSTANT, QDOM_DEFAULT, nothingTypeInfo);

   // nothing PseudoNothing::lastValue(){}
   QC_PSEUDONOTHING->addMethodExtended3("lastValue", (q_method_t)PseudoNothing_lastValue, false, QC_CONSTANT, QDOM_DEFAULT, nothingTypeInfo);

   // int PseudoNothing::lsize(){}
   QC_PSEUDONOTHING->addMethodExtended3("lsize", (q_method_int64_t)PseudoNothing_lsize, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   // SingleValueIterator PseudoNothing::pairIterator(){}
   QC_PSEUDONOTHING->addMethodExtended3("pairIterator", (q_method_t)PseudoNothing_pairIterator, false, QC_CONSTANT, QDOM_DEFAULT, QC_SINGLEVALUEITERATOR->getTypeInfo());

   // SingleValueIterator PseudoNothing::rangeIterator(){}
   QC_PSEUDONOTHING->addMethodExtended3("rangeIterator", (q_method_t)PseudoNothing_rangeIterator, false, QC_CONSTANT, QDOM_DEFAULT, QC_SINGLEVALUEITERATOR->getTypeInfo());

   // int PseudoNothing::typeCode(){}
   QC_PSEUDONOTHING->addMethodExtended3("typeCode", (q_method_int64_t)PseudoNothing_typeCode, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   // list PseudoNothing::values(){}
   QC_PSEUDONOTHING->addMethodExtended3("values", (q_method_t)PseudoNothing_values, false, QC_CONSTANT, QDOM_DEFAULT, listTypeInfo);

   return QC_PSEUDONOTHING;
}
