/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_AbstractBidirectionalIterator.qpp AbstractBidirectionalIterator class (interface) definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
/* Qore class Qore::AbstractBidirectionalIterator */

qore_classid_t CID_ABSTRACTBIDIRECTIONALITERATOR;
QoreClass* QC_ABSTRACTBIDIRECTIONALITERATOR;

DLLLOCAL QoreClass* initAbstractBidirectionalIteratorClass(QoreNamespace& ns) {
   QC_ABSTRACTBIDIRECTIONALITERATOR = new QoreClass("AbstractBidirectionalIterator", QDOM_DEFAULT);
   CID_ABSTRACTBIDIRECTIONALITERATOR = QC_ABSTRACTBIDIRECTIONALITERATOR->getID();

   // set parent class
   assert(QC_ABSTRACTITERATOR);
   QC_ABSTRACTBIDIRECTIONALITERATOR->addBuiltinVirtualBaseClass(QC_ABSTRACTITERATOR);

   // bool AbstractBidirectionalIterator::prev();
   QC_ABSTRACTBIDIRECTIONALITERATOR->addAbstractMethodVariantExtended3("prev", false, QC_NO_FLAGS, boolTypeInfo);

   return QC_ABSTRACTBIDIRECTIONALITERATOR;
}
