/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_AbstractIterator.qpp AbstractIterator class (interface) definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
/* Qore class Qore::AbstractIterator */

qore_classid_t CID_ABSTRACTITERATOR;
QoreClass* QC_ABSTRACTITERATOR;

DLLLOCAL QoreClass* initAbstractIteratorClass(QoreNamespace& ns) {
   QC_ABSTRACTITERATOR = new QoreClass("AbstractIterator", QDOM_DEFAULT);
   CID_ABSTRACTITERATOR = QC_ABSTRACTITERATOR->getID();

   // any AbstractIterator::getValue();
   QC_ABSTRACTITERATOR->addAbstractMethodVariantExtended3("getValue", false, QC_NO_FLAGS, anyTypeInfo);

   // bool AbstractIterator::next();
   QC_ABSTRACTITERATOR->addAbstractMethodVariantExtended3("next", false, QC_NO_FLAGS, boolTypeInfo);

   // bool AbstractIterator::valid();
   QC_ABSTRACTITERATOR->addAbstractMethodVariantExtended3("valid", false, QC_NO_FLAGS, boolTypeInfo);

   return QC_ABSTRACTITERATOR;
}
