/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_AbstractQuantifiedIterator.qpp AbstractQuantifiedIterator class (interface) definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
/* Qore class Qore::AbstractQuantifiedIterator */

qore_classid_t CID_ABSTRACTQUANTIFIEDITERATOR;
QoreClass* QC_ABSTRACTQUANTIFIEDITERATOR;

DLLLOCAL QoreClass* initAbstractQuantifiedIteratorClass(QoreNamespace& ns) {
   QC_ABSTRACTQUANTIFIEDITERATOR = new QoreClass("AbstractQuantifiedIterator", QDOM_DEFAULT);
   CID_ABSTRACTQUANTIFIEDITERATOR = QC_ABSTRACTQUANTIFIEDITERATOR->getID();

   // set parent class
   assert(QC_ABSTRACTITERATOR);
   QC_ABSTRACTQUANTIFIEDITERATOR->addBuiltinVirtualBaseClass(QC_ABSTRACTITERATOR);

   // bool AbstractQuantifiedIterator::empty();
   QC_ABSTRACTQUANTIFIEDITERATOR->addAbstractMethodVariantExtended3("empty", false, QC_NO_FLAGS, boolTypeInfo);

   // bool AbstractQuantifiedIterator::first();
   QC_ABSTRACTQUANTIFIEDITERATOR->addAbstractMethodVariantExtended3("first", false, QC_NO_FLAGS, boolTypeInfo);

   // bool AbstractQuantifiedIterator::last();
   QC_ABSTRACTQUANTIFIEDITERATOR->addAbstractMethodVariantExtended3("last", false, QC_NO_FLAGS, boolTypeInfo);

   return QC_ABSTRACTQUANTIFIEDITERATOR;
}
