/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
 QC_AbstractSmartLock.qpp
 
 Qore Programming Language
 
 Copyright 2003 - 2013 David Nichols
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <qore/Qore.h>
#include <qore/intern/QC_AbstractSmartLock.h>
/* Qore class Qore::Thread::AbstractSmartLock */

qore_classid_t CID_ABSTRACTSMARTLOCK;
QoreClass* QC_ABSTRACTSMARTLOCK;

// AbstractSmartLock::constructor() {}
static void AbstractSmartLock_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 40 "QC_AbstractSmartLock.qpp"
xsink->raiseException("ABSTRACTSMARTLOCK-CONSTRUCTOR-ERROR", "this class is an abstract class and cannot be constructed directly or inherited directly by a user-defined class");
}

// string AbstractSmartLock::getName(){}
static AbstractQoreNode* AbstractSmartLock_getName(QoreObject* self, AbstractSmartLock* asl, const QoreListNode* args, ExceptionSink* xsink) {
# 52 "QC_AbstractSmartLock.qpp"
return new QoreStringNode(asl->getName());
}

// bool AbstractSmartLock::lockOwner(){}
static bool AbstractSmartLock_lockOwner(QoreObject* self, AbstractSmartLock* asl, const QoreListNode* args, ExceptionSink* xsink) {
# 70 "QC_AbstractSmartLock.qpp"
return asl->get_tid() == gettid();
}

// int AbstractSmartLock::lockTID(){}
static int64 AbstractSmartLock_lockTID(QoreObject* self, AbstractSmartLock* asl, const QoreListNode* args, ExceptionSink* xsink) {
# 84 "QC_AbstractSmartLock.qpp"
int tid = asl->get_tid();
   return !tid ? -1 : tid;
}

DLLLOCAL QoreClass* initAbstractSmartLockClass(QoreNamespace& ns) {
   QC_ABSTRACTSMARTLOCK = new QoreClass("AbstractSmartLock", QDOM_THREAD_CLASS);
   CID_ABSTRACTSMARTLOCK = QC_ABSTRACTSMARTLOCK->getID();

   // AbstractSmartLock::constructor() {}
   QC_ABSTRACTSMARTLOCK->setConstructorExtended3(AbstractSmartLock_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // string AbstractSmartLock::getName(){}
   QC_ABSTRACTSMARTLOCK->addMethodExtended3("getName", (q_method_t)AbstractSmartLock_getName, false, QC_CONSTANT, QDOM_DEFAULT, stringTypeInfo);

   // bool AbstractSmartLock::lockOwner(){}
   QC_ABSTRACTSMARTLOCK->addMethodExtended3("lockOwner", (q_method_bool_t)AbstractSmartLock_lockOwner, false, QC_CONSTANT, QDOM_DEFAULT, boolTypeInfo);

   // int AbstractSmartLock::lockTID(){}
   QC_ABSTRACTSMARTLOCK->addMethodExtended3("lockTID", (q_method_int64_t)AbstractSmartLock_lockTID, false, QC_CONSTANT, QDOM_DEFAULT, bigIntTypeInfo);

   return QC_ABSTRACTSMARTLOCK;
}
