/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
 QC_AutoGate.qpp
 
 Qore Programming Language
 
 Copyright 2003 - 2013 David Nichols
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <qore/Qore.h>
#include <qore/intern/QC_AutoGate.h>
#include <qore/intern/QC_Gate.h>
/* Qore class Qore::Thread::AutoGate */

qore_classid_t CID_AUTOGATE;
QoreClass* QC_AUTOGATE;

// AutoGate::constructor(Gate gate) {}
static void AutoGate_constructor_C4Gate(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   HARD_QORE_OBJ_DATA(gate, QoreGate, args, 0, CID_GATE, "AutoGate::constructor()", "Gate", xsink);
   if (*xsink)
      return;
# 61 "QC_AutoGate.qpp"
QoreAutoGate *ag = new QoreAutoGate(gate, xsink);
   if (*xsink)
      ag->deref(xsink);
   else
      self->setPrivate(CID_AUTOGATE, ag);
}

// AutoGate::copy() {}
static void AutoGate_copy(QoreObject* self, QoreObject* old, QoreAutoGate* ag, ExceptionSink* xsink) {
# 85 "QC_AutoGate.qpp"
xsink->raiseException("AUTOGATE-COPY-ERROR", "objects of this class cannot be copied");
}

// AutoGate::destructor() {}
static void AutoGate_destructor(QoreObject* self, QoreAutoGate* ag, ExceptionSink* xsink) {
# 76 "QC_AutoGate.qpp"
ag->destructor(xsink);
   ag->deref(xsink);
}

DLLLOCAL QoreClass* initAutoGateClass(QoreNamespace& ns) {
   QC_AUTOGATE = new QoreClass("AutoGate", QDOM_THREAD_CLASS);
   CID_AUTOGATE = QC_AUTOGATE->getID();

   // AutoGate::constructor(Gate gate) {}
   QC_AUTOGATE->setConstructorExtended3(AutoGate_constructor_C4Gate, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, QC_GATE->getTypeInfo(), NULL, "gate");

   // AutoGate::copy() {}
   QC_AUTOGATE->setCopy((q_copy_t)AutoGate_copy);

   // AutoGate::destructor() {}
   QC_AUTOGATE->setDestructor((q_destructor_t)AutoGate_destructor);

   return QC_AUTOGATE;
}
