/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
 QC_AutoWriteLock.cpp
 
 Qore Programming Language
 
 Copyright 2003 - 2013 David Nichols
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or (at your option) any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

#include <qore/Qore.h>
#include <qore/intern/QC_AutoWriteLock.h>
#include <qore/intern/QC_RWLock.h>
/* Qore class Qore::Thread::AutoWriteLock */

qore_classid_t CID_AUTOWRITELOCK;
QoreClass* QC_AUTOWRITELOCK;

// AutoWriteLock::constructor(RWLock rwl) {}
static void AutoWriteLock_constructor_C6RWLock(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   HARD_QORE_OBJ_DATA(rwl, RWLock, args, 0, CID_RWLOCK, "AutoWriteLock::constructor()", "RWLock", xsink);
   if (*xsink)
      return;
# 65 "QC_AutoWriteLock.qpp"
ReferenceHolder<QoreAutoWriteLock> arwl(new QoreAutoWriteLock(rwl, xsink), xsink);
   if (!*xsink)
      self->setPrivate(CID_AUTOWRITELOCK, arwl.release());
}

// AutoWriteLock::copy() {}
static void AutoWriteLock_copy(QoreObject* self, QoreObject* old, QoreAutoWriteLock* arwl, ExceptionSink* xsink) {
# 89 "QC_AutoWriteLock.qpp"
xsink->raiseException("AUTOWRITELOCK-COPY-ERROR", "objects of this class cannot be copied");
}

// AutoWriteLock::destructor() {}
static void AutoWriteLock_destructor(QoreObject* self, QoreAutoWriteLock* arwl, ExceptionSink* xsink) {
# 80 "QC_AutoWriteLock.qpp"
arwl->destructor(xsink);
   arwl->deref(xsink);
}

DLLLOCAL QoreClass* initAutoWriteLockClass(QoreNamespace& ns) {
   QC_AUTOWRITELOCK = new QoreClass("AutoWriteLock", QDOM_THREAD_CLASS);
   CID_AUTOWRITELOCK = QC_AUTOWRITELOCK->getID();

   // AutoWriteLock::constructor(RWLock rwl) {}
   QC_AUTOWRITELOCK->setConstructorExtended3(AutoWriteLock_constructor_C6RWLock, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, QC_RWLOCK->getTypeInfo(), NULL, "rwl");

   // AutoWriteLock::copy() {}
   QC_AUTOWRITELOCK->setCopy((q_copy_t)AutoWriteLock_copy);

   // AutoWriteLock::destructor() {}
   QC_AUTOWRITELOCK->setDestructor((q_destructor_t)AutoWriteLock_destructor);

   return QC_AUTOWRITELOCK;
}
