/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_HashKeyReverseIterator.qpp HashKeyReverseIterator class definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/QoreHashIterator.h>
/* Qore class Qore::HashKeyReverseIterator */

qore_classid_t CID_HASHKEYREVERSEITERATOR;
QoreClass* QC_HASHKEYREVERSEITERATOR;

// HashKeyReverseIterator::constructor(hash h) {}
static void HashKeyReverseIterator_constructor_Vh(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   const QoreHashNode* h = HARD_QORE_HASH(args, 0);
# 71 "QC_HashKeyReverseIterator.qpp"
self->setPrivate(CID_HASHKEYREVERSEITERATOR, new QoreHashReverseIterator(h));
}

// HashKeyReverseIterator::constructor() {}
static void HashKeyReverseIterator_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 82 "QC_HashKeyReverseIterator.qpp"
self->setPrivate(CID_HASHKEYREVERSEITERATOR, new QoreHashReverseIterator);
}

// HashKeyReverseIterator::copy() {}
static void HashKeyReverseIterator_copy(QoreObject* self, QoreObject* old, QoreHashReverseIterator* i, ExceptionSink* xsink) {
# 92 "QC_HashKeyReverseIterator.qpp"
self->setPrivate(CID_HASHKEYREVERSEITERATOR, new QoreHashReverseIterator(*i));
}

// string HashKeyReverseIterator::getValue(){}
static AbstractQoreNode* HashKeyReverseIterator_getValue(QoreObject* self, QoreHashReverseIterator* i, const QoreListNode* args, ExceptionSink* xsink) {
# 109 "QC_HashKeyReverseIterator.qpp"
if (i->check(xsink))
      return 0;
   return i->getKey(xsink);
}

DLLLOCAL QoreClass* initHashKeyReverseIteratorClass(QoreNamespace& ns) {
   QC_HASHKEYREVERSEITERATOR = new QoreClass("HashKeyReverseIterator", QDOM_DEFAULT);
   CID_HASHKEYREVERSEITERATOR = QC_HASHKEYREVERSEITERATOR->getID();

   // set parent class
   assert(QC_HASHREVERSEITERATOR);
   QC_HASHKEYREVERSEITERATOR->addBuiltinVirtualBaseClass(QC_HASHREVERSEITERATOR);

   // HashKeyReverseIterator::constructor(hash h) {}
   QC_HASHKEYREVERSEITERATOR->setConstructorExtended3(HashKeyReverseIterator_constructor_Vh, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, hashTypeInfo, NULL, "h");

   // HashKeyReverseIterator::constructor() {}
   QC_HASHKEYREVERSEITERATOR->setConstructorExtended3(HashKeyReverseIterator_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // HashKeyReverseIterator::copy() {}
   QC_HASHKEYREVERSEITERATOR->setCopy((q_copy_t)HashKeyReverseIterator_copy);

   // string HashKeyReverseIterator::getValue(){}
   QC_HASHKEYREVERSEITERATOR->addMethodExtended3("getValue", (q_method_t)HashKeyReverseIterator_getValue, false, QC_RET_VALUE_ONLY, QDOM_DEFAULT, stringTypeInfo);

   return QC_HASHKEYREVERSEITERATOR;
}
