/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_HashPairIterator.qpp HashPairIterator class definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/QoreHashIterator.h>
/* Qore class Qore::HashPairIterator */

qore_classid_t CID_HASHPAIRITERATOR;
QoreClass* QC_HASHPAIRITERATOR;

// HashPairIterator::constructor(hash h) {}
static void HashPairIterator_constructor_Vh(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   const QoreHashNode* h = HARD_QORE_HASH(args, 0);
# 66 "QC_HashPairIterator.qpp"
self->setPrivate(CID_HASHPAIRITERATOR, new QoreHashIterator(h));
}

// HashPairIterator::constructor() {}
static void HashPairIterator_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 77 "QC_HashPairIterator.qpp"
self->setPrivate(CID_HASHPAIRITERATOR, new QoreHashIterator);
}

// HashPairIterator::copy() {}
static void HashPairIterator_copy(QoreObject* self, QoreObject* old, QoreHashIterator* i, ExceptionSink* xsink) {
# 87 "QC_HashPairIterator.qpp"
self->setPrivate(CID_HASHPAIRITERATOR, new QoreHashIterator(*i));
}

// hash HashPairIterator::getValue(){}
static AbstractQoreNode* HashPairIterator_getValue(QoreObject* self, QoreHashIterator* i, const QoreListNode* args, ExceptionSink* xsink) {
# 104 "QC_HashPairIterator.qpp"
if (i->check(xsink))
      return 0;
   return i->getReferencedValuePair(xsink);
}

DLLLOCAL QoreClass* initHashPairIteratorClass(QoreNamespace& ns) {
   QC_HASHPAIRITERATOR = new QoreClass("HashPairIterator", QDOM_DEFAULT);
   CID_HASHPAIRITERATOR = QC_HASHPAIRITERATOR->getID();

   // set parent class
   assert(QC_HASHITERATOR);
   QC_HASHPAIRITERATOR->addBuiltinVirtualBaseClass(QC_HASHITERATOR);

   // HashPairIterator::constructor(hash h) {}
   QC_HASHPAIRITERATOR->setConstructorExtended3(HashPairIterator_constructor_Vh, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, hashTypeInfo, NULL, "h");

   // HashPairIterator::constructor() {}
   QC_HASHPAIRITERATOR->setConstructorExtended3(HashPairIterator_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // HashPairIterator::copy() {}
   QC_HASHPAIRITERATOR->setCopy((q_copy_t)HashPairIterator_copy);

   // hash HashPairIterator::getValue(){}
   QC_HASHPAIRITERATOR->addMethodExtended3("getValue", (q_method_t)HashPairIterator_getValue, false, QC_RET_VALUE_ONLY, QDOM_DEFAULT, hashTypeInfo);

   return QC_HASHPAIRITERATOR;
}
