/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_HashPairReverseIterator.qpp HashPairReverseIterator class definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/QoreHashIterator.h>
/* Qore class Qore::HashPairReverseIterator */

qore_classid_t CID_HASHPAIRREVERSEITERATOR;
QoreClass* QC_HASHPAIRREVERSEITERATOR;

// HashPairReverseIterator::constructor(hash h) {}
static void HashPairReverseIterator_constructor_Vh(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   const QoreHashNode* h = HARD_QORE_HASH(args, 0);
# 71 "QC_HashPairReverseIterator.qpp"
self->setPrivate(CID_HASHPAIRREVERSEITERATOR, new QoreHashReverseIterator(h));
}

// HashPairReverseIterator::constructor() {}
static void HashPairReverseIterator_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 82 "QC_HashPairReverseIterator.qpp"
self->setPrivate(CID_HASHPAIRREVERSEITERATOR, new QoreHashReverseIterator);
}

// HashPairReverseIterator::copy() {}
static void HashPairReverseIterator_copy(QoreObject* self, QoreObject* old, QoreHashReverseIterator* i, ExceptionSink* xsink) {
# 92 "QC_HashPairReverseIterator.qpp"
self->setPrivate(CID_HASHPAIRREVERSEITERATOR, new QoreHashReverseIterator(*i));
}

// string HashPairReverseIterator::getValue(){}
static AbstractQoreNode* HashPairReverseIterator_getValue(QoreObject* self, QoreHashReverseIterator* i, const QoreListNode* args, ExceptionSink* xsink) {
# 109 "QC_HashPairReverseIterator.qpp"
if (i->check(xsink))
      return 0;
   return i->getReferencedValuePair(xsink);
}

DLLLOCAL QoreClass* initHashPairReverseIteratorClass(QoreNamespace& ns) {
   QC_HASHPAIRREVERSEITERATOR = new QoreClass("HashPairReverseIterator", QDOM_DEFAULT);
   CID_HASHPAIRREVERSEITERATOR = QC_HASHPAIRREVERSEITERATOR->getID();

   // set parent class
   assert(QC_HASHREVERSEITERATOR);
   QC_HASHPAIRREVERSEITERATOR->addBuiltinVirtualBaseClass(QC_HASHREVERSEITERATOR);

   // HashPairReverseIterator::constructor(hash h) {}
   QC_HASHPAIRREVERSEITERATOR->setConstructorExtended3(HashPairReverseIterator_constructor_Vh, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, hashTypeInfo, NULL, "h");

   // HashPairReverseIterator::constructor() {}
   QC_HASHPAIRREVERSEITERATOR->setConstructorExtended3(HashPairReverseIterator_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // HashPairReverseIterator::copy() {}
   QC_HASHPAIRREVERSEITERATOR->setCopy((q_copy_t)HashPairReverseIterator_copy);

   // string HashPairReverseIterator::getValue(){}
   QC_HASHPAIRREVERSEITERATOR->addMethodExtended3("getValue", (q_method_t)HashPairReverseIterator_getValue, false, QC_RET_VALUE_ONLY, QDOM_DEFAULT, stringTypeInfo);

   return QC_HASHPAIRREVERSEITERATOR;
}
