/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_HashIterator.qpp HashIterator class definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/QoreObjectIterator.h>
/* Qore class Qore::ObjectIterator */

qore_classid_t CID_OBJECTITERATOR;
QoreClass* QC_OBJECTITERATOR;

// ObjectIterator::constructor(object o) {}
static void ObjectIterator_constructor_Vo(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   QoreObject* o = HARD_QORE_OBJECT(args, 0);
# 71 "QC_ObjectIterator.qpp"
self->setPrivate(CID_OBJECTITERATOR, new QoreObjectIterator(o));
}

// ObjectIterator::constructor() {}
static void ObjectIterator_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 82 "QC_ObjectIterator.qpp"
self->setPrivate(CID_OBJECTITERATOR, new QoreObjectIterator);
}

// ObjectIterator::copy() {}
static void ObjectIterator_copy(QoreObject* self, QoreObject* old, QoreObjectIterator* i, ExceptionSink* xsink) {
# 92 "QC_ObjectIterator.qpp"
self->setPrivate(CID_OBJECTITERATOR, new QoreObjectIterator(*i));
}

DLLLOCAL QoreClass* initObjectIteratorClass(QoreNamespace& ns) {
   QC_OBJECTITERATOR = new QoreClass("ObjectIterator", QDOM_DEFAULT);
   CID_OBJECTITERATOR = QC_OBJECTITERATOR->getID();

   // set parent class
   assert(QC_HASHITERATOR);
   QC_OBJECTITERATOR->addBuiltinVirtualBaseClass(QC_HASHITERATOR);

   // ObjectIterator::constructor(object o) {}
   QC_OBJECTITERATOR->setConstructorExtended3(ObjectIterator_constructor_Vo, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, objectTypeInfo, NULL, "o");

   // ObjectIterator::constructor() {}
   QC_OBJECTITERATOR->setConstructorExtended3(ObjectIterator_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // ObjectIterator::copy() {}
   QC_OBJECTITERATOR->setCopy((q_copy_t)ObjectIterator_copy);

   return QC_OBJECTITERATOR;
}
