/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_ObjectKeyIterator.qpp ObjectKeyIterator class definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/QoreObjectIterator.h>
/* Qore class Qore::ObjectKeyIterator */

qore_classid_t CID_OBJECTKEYITERATOR;
QoreClass* QC_OBJECTKEYITERATOR;

// ObjectKeyIterator::constructor(object o) {}
static void ObjectKeyIterator_constructor_Vo(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   QoreObject* o = HARD_QORE_OBJECT(args, 0);
# 71 "QC_ObjectKeyIterator.qpp"
self->setPrivate(CID_OBJECTKEYITERATOR, new QoreObjectIterator(o));
}

// ObjectKeyIterator::constructor() {}
static void ObjectKeyIterator_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 82 "QC_ObjectKeyIterator.qpp"
self->setPrivate(CID_OBJECTKEYITERATOR, new QoreObjectIterator);
}

// ObjectKeyIterator::copy() {}
static void ObjectKeyIterator_copy(QoreObject* self, QoreObject* old, QoreObjectIterator* i, ExceptionSink* xsink) {
# 92 "QC_ObjectKeyIterator.qpp"
self->setPrivate(CID_OBJECTKEYITERATOR, new QoreObjectIterator(*i));
}

// string ObjectKeyIterator::getValue(){}
static AbstractQoreNode* ObjectKeyIterator_getValue(QoreObject* self, QoreObjectIterator* i, const QoreListNode* args, ExceptionSink* xsink) {
# 108 "QC_ObjectKeyIterator.qpp"
if (i->check(xsink))
      return 0;
   return i->getKey(xsink);
}

DLLLOCAL QoreClass* initObjectKeyIteratorClass(QoreNamespace& ns) {
   QC_OBJECTKEYITERATOR = new QoreClass("ObjectKeyIterator", QDOM_DEFAULT);
   CID_OBJECTKEYITERATOR = QC_OBJECTKEYITERATOR->getID();

   // set parent class
   assert(QC_OBJECTITERATOR);
   QC_OBJECTKEYITERATOR->addBuiltinVirtualBaseClass(QC_OBJECTITERATOR);

   // ObjectKeyIterator::constructor(object o) {}
   QC_OBJECTKEYITERATOR->setConstructorExtended3(ObjectKeyIterator_constructor_Vo, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, objectTypeInfo, NULL, "o");

   // ObjectKeyIterator::constructor() {}
   QC_OBJECTKEYITERATOR->setConstructorExtended3(ObjectKeyIterator_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // ObjectKeyIterator::copy() {}
   QC_OBJECTKEYITERATOR->setCopy((q_copy_t)ObjectKeyIterator_copy);

   // string ObjectKeyIterator::getValue(){}
   QC_OBJECTKEYITERATOR->addMethodExtended3("getValue", (q_method_t)ObjectKeyIterator_getValue, false, QC_RET_VALUE_ONLY, QDOM_DEFAULT, stringTypeInfo);

   return QC_OBJECTKEYITERATOR;
}
