/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_ObjectKeyReverseIterator.qpp ObjectKeyReverseIterator class definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/QoreObjectIterator.h>
/* Qore class Qore::ObjectKeyReverseIterator */

qore_classid_t CID_OBJECTKEYREVERSEITERATOR;
QoreClass* QC_OBJECTKEYREVERSEITERATOR;

// ObjectKeyReverseIterator::constructor(object o) {}
static void ObjectKeyReverseIterator_constructor_Vo(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   QoreObject* o = HARD_QORE_OBJECT(args, 0);
# 76 "QC_ObjectKeyReverseIterator.qpp"
self->setPrivate(CID_OBJECTKEYREVERSEITERATOR, new QoreObjectReverseIterator(o));
}

// ObjectKeyReverseIterator::constructor() {}
static void ObjectKeyReverseIterator_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 87 "QC_ObjectKeyReverseIterator.qpp"
self->setPrivate(CID_OBJECTKEYREVERSEITERATOR, new QoreObjectReverseIterator);
}

// ObjectKeyReverseIterator::copy() {}
static void ObjectKeyReverseIterator_copy(QoreObject* self, QoreObject* old, QoreObjectReverseIterator* i, ExceptionSink* xsink) {
# 97 "QC_ObjectKeyReverseIterator.qpp"
self->setPrivate(CID_OBJECTKEYREVERSEITERATOR, new QoreObjectReverseIterator(*i));
}

// string ObjectKeyReverseIterator::getValue(){}
static AbstractQoreNode* ObjectKeyReverseIterator_getValue(QoreObject* self, QoreObjectReverseIterator* i, const QoreListNode* args, ExceptionSink* xsink) {
# 114 "QC_ObjectKeyReverseIterator.qpp"
if (i->check(xsink))
      return 0;
   return i->getKey(xsink);
}

DLLLOCAL QoreClass* initObjectKeyReverseIteratorClass(QoreNamespace& ns) {
   QC_OBJECTKEYREVERSEITERATOR = new QoreClass("ObjectKeyReverseIterator", QDOM_DEFAULT);
   CID_OBJECTKEYREVERSEITERATOR = QC_OBJECTKEYREVERSEITERATOR->getID();

   // set parent class
   assert(QC_OBJECTREVERSEITERATOR);
   QC_OBJECTKEYREVERSEITERATOR->addBuiltinVirtualBaseClass(QC_OBJECTREVERSEITERATOR);

   // ObjectKeyReverseIterator::constructor(object o) {}
   QC_OBJECTKEYREVERSEITERATOR->setConstructorExtended3(ObjectKeyReverseIterator_constructor_Vo, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, objectTypeInfo, NULL, "o");

   // ObjectKeyReverseIterator::constructor() {}
   QC_OBJECTKEYREVERSEITERATOR->setConstructorExtended3(ObjectKeyReverseIterator_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // ObjectKeyReverseIterator::copy() {}
   QC_OBJECTKEYREVERSEITERATOR->setCopy((q_copy_t)ObjectKeyReverseIterator_copy);

   // string ObjectKeyReverseIterator::getValue(){}
   QC_OBJECTKEYREVERSEITERATOR->addMethodExtended3("getValue", (q_method_t)ObjectKeyReverseIterator_getValue, false, QC_RET_VALUE_ONLY, QDOM_DEFAULT, stringTypeInfo);

   return QC_OBJECTKEYREVERSEITERATOR;
}
