/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_ObjectIterator.qpp ObjectIterator class definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/QoreObjectIterator.h>
/* Qore class Qore::ObjectPairIterator */

qore_classid_t CID_OBJECTPAIRITERATOR;
QoreClass* QC_OBJECTPAIRITERATOR;

// ObjectPairIterator::constructor(object o) {}
static void ObjectPairIterator_constructor_Vo(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   QoreObject* o = HARD_QORE_OBJECT(args, 0);
# 71 "QC_ObjectPairIterator.qpp"
self->setPrivate(CID_OBJECTPAIRITERATOR, new QoreObjectIterator(o));
}

// ObjectPairIterator::constructor() {}
static void ObjectPairIterator_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 82 "QC_ObjectPairIterator.qpp"
self->setPrivate(CID_OBJECTPAIRITERATOR, new QoreObjectIterator);
}

// ObjectPairIterator::copy() {}
static void ObjectPairIterator_copy(QoreObject* self, QoreObject* old, QoreObjectIterator* i, ExceptionSink* xsink) {
# 92 "QC_ObjectPairIterator.qpp"
self->setPrivate(CID_OBJECTPAIRITERATOR, new QoreObjectIterator(*i));
}

// hash ObjectPairIterator::getValue(){}
static AbstractQoreNode* ObjectPairIterator_getValue(QoreObject* self, QoreObjectIterator* i, const QoreListNode* args, ExceptionSink* xsink) {
# 109 "QC_ObjectPairIterator.qpp"
if (i->check(xsink))
      return 0;
   return i->getReferencedValuePair(xsink);
}

DLLLOCAL QoreClass* initObjectPairIteratorClass(QoreNamespace& ns) {
   QC_OBJECTPAIRITERATOR = new QoreClass("ObjectPairIterator", QDOM_DEFAULT);
   CID_OBJECTPAIRITERATOR = QC_OBJECTPAIRITERATOR->getID();

   // set parent class
   assert(QC_OBJECTITERATOR);
   QC_OBJECTPAIRITERATOR->addBuiltinVirtualBaseClass(QC_OBJECTITERATOR);

   // ObjectPairIterator::constructor(object o) {}
   QC_OBJECTPAIRITERATOR->setConstructorExtended3(ObjectPairIterator_constructor_Vo, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, objectTypeInfo, NULL, "o");

   // ObjectPairIterator::constructor() {}
   QC_OBJECTPAIRITERATOR->setConstructorExtended3(ObjectPairIterator_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // ObjectPairIterator::copy() {}
   QC_OBJECTPAIRITERATOR->setCopy((q_copy_t)ObjectPairIterator_copy);

   // hash ObjectPairIterator::getValue(){}
   QC_OBJECTPAIRITERATOR->addMethodExtended3("getValue", (q_method_t)ObjectPairIterator_getValue, false, QC_RET_VALUE_ONLY, QDOM_DEFAULT, hashTypeInfo);

   return QC_OBJECTPAIRITERATOR;
}
