/* -*- mode: c++; indent-tabs-mode: nil -*- */
/** @file QC_ObjectPairReverseIterator.qpp ObjectPairReverseIterator class definition */
/*
  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/QoreObjectIterator.h>
/* Qore class Qore::ObjectPairReverseIterator */

qore_classid_t CID_OBJECTPAIRREVERSEITERATOR;
QoreClass* QC_OBJECTPAIRREVERSEITERATOR;

// ObjectPairReverseIterator::constructor(object o) {}
static void ObjectPairReverseIterator_constructor_Vo(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
   QoreObject* o = HARD_QORE_OBJECT(args, 0);
# 76 "QC_ObjectPairReverseIterator.qpp"
self->setPrivate(CID_OBJECTPAIRREVERSEITERATOR, new QoreObjectReverseIterator(o));
}

// ObjectPairReverseIterator::constructor() {}
static void ObjectPairReverseIterator_constructor(QoreObject* self, const QoreListNode* args, ExceptionSink* xsink) {
# 87 "QC_ObjectPairReverseIterator.qpp"
self->setPrivate(CID_OBJECTPAIRREVERSEITERATOR, new QoreObjectReverseIterator);
}

// ObjectPairReverseIterator::copy() {}
static void ObjectPairReverseIterator_copy(QoreObject* self, QoreObject* old, QoreObjectReverseIterator* i, ExceptionSink* xsink) {
# 97 "QC_ObjectPairReverseIterator.qpp"
self->setPrivate(CID_OBJECTPAIRREVERSEITERATOR, new QoreObjectReverseIterator(*i));
}

// string ObjectPairReverseIterator::getValue(){}
static AbstractQoreNode* ObjectPairReverseIterator_getValue(QoreObject* self, QoreObjectReverseIterator* i, const QoreListNode* args, ExceptionSink* xsink) {
# 115 "QC_ObjectPairReverseIterator.qpp"
if (i->check(xsink))
      return 0;
   return i->getReferencedValuePair(xsink);
}

DLLLOCAL QoreClass* initObjectPairReverseIteratorClass(QoreNamespace& ns) {
   QC_OBJECTPAIRREVERSEITERATOR = new QoreClass("ObjectPairReverseIterator", QDOM_DEFAULT);
   CID_OBJECTPAIRREVERSEITERATOR = QC_OBJECTPAIRREVERSEITERATOR->getID();

   // set parent class
   assert(QC_OBJECTREVERSEITERATOR);
   QC_OBJECTPAIRREVERSEITERATOR->addBuiltinVirtualBaseClass(QC_OBJECTREVERSEITERATOR);

   // ObjectPairReverseIterator::constructor(object o) {}
   QC_OBJECTPAIRREVERSEITERATOR->setConstructorExtended3(ObjectPairReverseIterator_constructor_Vo, false, QC_NO_FLAGS, QDOM_DEFAULT, 1, objectTypeInfo, NULL, "o");

   // ObjectPairReverseIterator::constructor() {}
   QC_OBJECTPAIRREVERSEITERATOR->setConstructorExtended3(ObjectPairReverseIterator_constructor, false, QC_NO_FLAGS, QDOM_DEFAULT);

   // ObjectPairReverseIterator::copy() {}
   QC_OBJECTPAIRREVERSEITERATOR->setCopy((q_copy_t)ObjectPairReverseIterator_copy);

   // string ObjectPairReverseIterator::getValue(){}
   QC_OBJECTPAIRREVERSEITERATOR->addMethodExtended3("getValue", (q_method_t)ObjectPairReverseIterator_getValue, false, QC_RET_VALUE_ONLY, QDOM_DEFAULT, stringTypeInfo);

   return QC_OBJECTPAIRREVERSEITERATOR;
}
