/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
  qc_errno.qpp

  Qore Programming Language

  Copyright 2003 - 2014 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>

#ifndef E2BIG
#define E2BIG -1
#endif
#ifndef EACCES
#define EACCES -1
#endif
#ifndef EADDRINUSE
#define EADDRINUSE -1
#endif
#ifndef EADDRNOTAVAIL
#define EADDRNOTAVAIL -1
#endif
#ifndef EAFNOSUPPORT
#define EAFNOSUPPORT -1
#endif
#ifndef EAGAIN
#define EAGAIN -1
#endif
#ifndef EALREADY
#define EALREADY -1
#endif
#ifndef EBADF
#define EBADF -1
#endif
#ifndef EBADMSG
#define EBADMSG -1
#endif
#ifndef EBUSY
#define EBUSY -1
#endif
#ifndef ECHILD
#define ECHILD -1
#endif
#ifndef ECONNABORTED
#define ECONNABORTED -1
#endif
#ifndef ECONNREFUSED
#define ECONNREFUSED -1
#endif
#ifndef ECONNRESET
#define ECONNRESET -1
#endif
#ifndef EDEADLK
#define EDEADLK -1
#endif
#ifndef EDEADLOCK
#define EDEADLOCK -1
#endif
#ifndef EDESTADDRREQ
#define EDESTADDRREQ -1
#endif
#ifndef EDOM
#define EDOM -1
#endif
#ifndef EDQUOT
#define EDQUOT -1
#endif
#ifndef EEXIST
#define EEXIST -1
#endif
#ifndef EFAULT
#define EFAULT -1
#endif
#ifndef EFBIG
#define EFBIG -1
#endif
#ifndef EHOSTDOWN
#define EHOSTDOWN -1
#endif
#ifndef EHOSTUNREACH
#define EHOSTUNREACH -1
#endif
#ifndef EIDRM
#define EIDRM -1
#endif
#ifndef EILSEQ
#define EILSEQ -1
#endif
#ifndef EINPROGRESS
#define EINPROGRESS -1
#endif
#ifndef EINTR
#define EINTR -1
#endif
#ifndef EINVAL
#define EINVAL -1
#endif
#ifndef EIO
#define EIO -1
#endif
#ifndef EISCONN
#define EISCONN -1
#endif
#ifndef EISDIR
#define EISDIR -1
#endif
#ifndef ELOOP
#define ELOOP -1
#endif
#ifndef EMFILE
#define EMFILE -1
#endif
#ifndef EMLINK
#define EMLINK -1
#endif
#ifndef EMSGSIZE
#define EMSGSIZE -1
#endif
#ifndef EMULTIHOP
#define EMULTIHOP -1
#endif
#ifndef ENAMETOOLONG
#define ENAMETOOLONG -1
#endif
#ifndef ENETDOWN
#define ENETDOWN -1
#endif
#ifndef ENETRESET
#define ENETRESET -1
#endif
#ifndef ENETUNREACH
#define ENETUNREACH -1
#endif
#ifndef ENFILE
#define ENFILE -1
#endif
#ifndef ENOBUFS
#define ENOBUFS -1
#endif
#ifndef ENODATA
#define ENODATA -1
#endif
#ifndef ENODEV
#define ENODEV -1
#endif
#ifndef ENOENT
#define ENOENT -1
#endif
#ifndef ENOEXEC
#define ENOEXEC -1
#endif
#ifndef ENOLCK
#define ENOLCK -1
#endif
#ifndef ENOLINK
#define ENOLINK -1
#endif
#ifndef ENOMEM
#define ENOMEM -1
#endif
#ifndef ENOMSG
#define ENOMSG -1
#endif
#ifndef ENOPROTOOPT
#define ENOPROTOOPT -1
#endif
#ifndef ENOSPC
#define ENOSPC -1
#endif
#ifndef ENOSR
#define ENOSR -1
#endif
#ifndef ENOSTR
#define ENOSTR -1
#endif
#ifndef ENOSYS
#define ENOSYS -1
#endif
#ifndef ENOTBLK
#define ENOTBLK -1
#endif
#ifndef ENOTCONN
#define ENOTCONN -1
#endif
#ifndef ENOTDIR
#define ENOTDIR -1
#endif
#ifndef ENOTEMPTY
#define ENOTEMPTY -1
#endif
#ifndef ENOTNAM
#define ENOTNAM -1
#endif
#ifndef ENOTSOCK
#define ENOTSOCK -1
#endif
#ifndef ENOTTY
#define ENOTTY -1
#endif
#ifndef ENXIO
#define ENXIO -1
#endif
#ifndef EOPNOTSUPP
#define EOPNOTSUPP -1
#endif
#ifndef EOVERFLOW
#define EOVERFLOW -1
#endif
#ifndef EPERM
#define EPERM -1
#endif
#ifndef EPFNOSUPPORT
#define EPFNOSUPPORT -1
#endif
#ifndef EPIPE
#define EPIPE -1
#endif
#ifndef EPROTO
#define EPROTO -1
#endif
#ifndef EPROTONOSUPPORT
#define EPROTONOSUPPORT -1
#endif
#ifndef EPROTOTYPE
#define EPROTOTYPE -1
#endif
#ifndef ERANGE
#define ERANGE -1
#endif
#ifndef EREMOTE
#define EREMOTE -1
#endif
#ifndef EROFS
#define EROFS -1
#endif
#ifndef ESHUTDOWN
#define ESHUTDOWN -1
#endif
#ifndef ESOCKTNOSUPPORT
#define ESOCKTNOSUPPORT -1
#endif
#ifndef ESTALE
#define ESTALE -1
#endif
#ifndef ETIME
#define ETIME -1
#endif
#ifndef ETIMEDOUT
#define ETIMEDOUT -1
#endif
#ifndef ETOOMANYREFS
#define ETOOMANYREFS -1
#endif
#ifndef ETXTBSY
#define ETXTBSY -1
#endif
#ifndef EUSERS
#define EUSERS -1
#endif
#ifndef EWOULDBLOCK
#define EWOULDBLOCK -1
#endif
#ifndef EXDEV
#define EXDEV -1
#endif
#ifndef ESRCH
#define ESRCH -1
#endif

DLLLOCAL void init_errno_constants(QoreNamespace& ns) {
# 286 "qc_errno.qpp"
# 292 "qc_errno.qpp"
# 295 "qc_errno.qpp"
# 298 "qc_errno.qpp"
# 301 "qc_errno.qpp"
# 304 "qc_errno.qpp"
# 307 "qc_errno.qpp"
# 310 "qc_errno.qpp"
# 313 "qc_errno.qpp"
# 316 "qc_errno.qpp"
# 319 "qc_errno.qpp"
# 322 "qc_errno.qpp"
# 325 "qc_errno.qpp"
# 328 "qc_errno.qpp"
# 331 "qc_errno.qpp"
# 334 "qc_errno.qpp"
# 337 "qc_errno.qpp"
# 340 "qc_errno.qpp"
# 343 "qc_errno.qpp"
# 346 "qc_errno.qpp"
# 349 "qc_errno.qpp"
# 352 "qc_errno.qpp"
# 355 "qc_errno.qpp"
# 358 "qc_errno.qpp"
# 361 "qc_errno.qpp"
# 364 "qc_errno.qpp"
# 367 "qc_errno.qpp"
# 370 "qc_errno.qpp"
# 373 "qc_errno.qpp"
# 376 "qc_errno.qpp"
# 379 "qc_errno.qpp"
# 382 "qc_errno.qpp"
# 385 "qc_errno.qpp"
# 388 "qc_errno.qpp"
# 391 "qc_errno.qpp"
# 394 "qc_errno.qpp"
# 397 "qc_errno.qpp"
# 400 "qc_errno.qpp"
# 403 "qc_errno.qpp"
# 406 "qc_errno.qpp"
# 409 "qc_errno.qpp"
# 412 "qc_errno.qpp"
# 415 "qc_errno.qpp"
# 418 "qc_errno.qpp"
# 421 "qc_errno.qpp"
# 424 "qc_errno.qpp"
# 427 "qc_errno.qpp"
# 430 "qc_errno.qpp"
# 433 "qc_errno.qpp"
# 436 "qc_errno.qpp"
# 439 "qc_errno.qpp"
# 442 "qc_errno.qpp"
# 445 "qc_errno.qpp"
# 448 "qc_errno.qpp"
# 451 "qc_errno.qpp"
# 454 "qc_errno.qpp"
# 457 "qc_errno.qpp"
# 460 "qc_errno.qpp"
# 463 "qc_errno.qpp"
# 466 "qc_errno.qpp"
# 469 "qc_errno.qpp"
# 472 "qc_errno.qpp"
# 475 "qc_errno.qpp"
# 478 "qc_errno.qpp"
# 481 "qc_errno.qpp"
# 484 "qc_errno.qpp"
# 487 "qc_errno.qpp"
# 490 "qc_errno.qpp"
# 493 "qc_errno.qpp"
# 496 "qc_errno.qpp"
# 499 "qc_errno.qpp"
# 502 "qc_errno.qpp"
# 505 "qc_errno.qpp"
# 508 "qc_errno.qpp"
# 511 "qc_errno.qpp"
# 514 "qc_errno.qpp"
# 517 "qc_errno.qpp"
# 520 "qc_errno.qpp"
# 523 "qc_errno.qpp"
# 526 "qc_errno.qpp"
# 529 "qc_errno.qpp"
# 532 "qc_errno.qpp"
# 535 "qc_errno.qpp"
# 538 "qc_errno.qpp"
# 541 "qc_errno.qpp"
# 544 "qc_errno.qpp"
   ns.addConstant("E2BIG", new QoreBigIntNode(E2BIG));
   ns.addConstant("EACCES", new QoreBigIntNode(EACCES));
   ns.addConstant("EADDRINUSE", new QoreBigIntNode(EADDRINUSE));
   ns.addConstant("EADDRNOTAVAIL", new QoreBigIntNode(EADDRNOTAVAIL));
   ns.addConstant("EAFNOSUPPORT", new QoreBigIntNode(EAFNOSUPPORT));
   ns.addConstant("EAGAIN", new QoreBigIntNode(EAGAIN));
   ns.addConstant("EALREADY", new QoreBigIntNode(EALREADY));
   ns.addConstant("EBADF", new QoreBigIntNode(EBADF));
   ns.addConstant("EBADMSG", new QoreBigIntNode(EBADMSG));
   ns.addConstant("EBUSY", new QoreBigIntNode(EBUSY));
   ns.addConstant("ECHILD", new QoreBigIntNode(ECHILD));
   ns.addConstant("ECONNABORTED", new QoreBigIntNode(ECONNABORTED));
   ns.addConstant("ECONNREFUSED", new QoreBigIntNode(ECONNREFUSED));
   ns.addConstant("ECONNRESET", new QoreBigIntNode(ECONNRESET));
   ns.addConstant("EDEADLK", new QoreBigIntNode(EDEADLK));
   ns.addConstant("EDEADLOCK", new QoreBigIntNode(EDEADLOCK));
   ns.addConstant("EDESTADDRREQ", new QoreBigIntNode(EDESTADDRREQ));
   ns.addConstant("EDOM", new QoreBigIntNode(EDOM));
   ns.addConstant("EDQUOT", new QoreBigIntNode(EDQUOT));
   ns.addConstant("EEXIST", new QoreBigIntNode(EEXIST));
   ns.addConstant("EFAULT", new QoreBigIntNode(EFAULT));
   ns.addConstant("EFBIG", new QoreBigIntNode(EFBIG));
   ns.addConstant("EHOSTDOWN", new QoreBigIntNode(EHOSTDOWN));
   ns.addConstant("EHOSTUNREACH", new QoreBigIntNode(EHOSTUNREACH));
   ns.addConstant("EIDRM", new QoreBigIntNode(EIDRM));
   ns.addConstant("EILSEQ", new QoreBigIntNode(EILSEQ));
   ns.addConstant("EINPROGRESS", new QoreBigIntNode(EINPROGRESS));
   ns.addConstant("EINTR", new QoreBigIntNode(EINTR));
   ns.addConstant("EINVAL", new QoreBigIntNode(EINVAL));
   ns.addConstant("EIO", new QoreBigIntNode(EIO));
   ns.addConstant("EISCONN", new QoreBigIntNode(EISCONN));
   ns.addConstant("EISDIR", new QoreBigIntNode(EISDIR));
   ns.addConstant("ELOOP", new QoreBigIntNode(ELOOP));
   ns.addConstant("EMFILE", new QoreBigIntNode(EMFILE));
   ns.addConstant("EMLINK", new QoreBigIntNode(EMLINK));
   ns.addConstant("EMSGSIZE", new QoreBigIntNode(EMSGSIZE));
   ns.addConstant("EMULTIHOP", new QoreBigIntNode(EMULTIHOP));
   ns.addConstant("ENAMETOOLONG", new QoreBigIntNode(ENAMETOOLONG));
   ns.addConstant("ENETDOWN", new QoreBigIntNode(ENETDOWN));
   ns.addConstant("ENETRESET", new QoreBigIntNode(ENETRESET));
   ns.addConstant("ENETUNREACH", new QoreBigIntNode(ENETUNREACH));
   ns.addConstant("ENFILE", new QoreBigIntNode(ENFILE));
   ns.addConstant("ENOBUFS", new QoreBigIntNode(ENOBUFS));
   ns.addConstant("ENODATA", new QoreBigIntNode(ENODATA));
   ns.addConstant("ENODEV", new QoreBigIntNode(ENODEV));
   ns.addConstant("ENOENT", new QoreBigIntNode(ENOENT));
   ns.addConstant("ENOEXEC", new QoreBigIntNode(ENOEXEC));
   ns.addConstant("ENOLCK", new QoreBigIntNode(ENOLCK));
   ns.addConstant("ENOLINK", new QoreBigIntNode(ENOLINK));
   ns.addConstant("ENOMEM", new QoreBigIntNode(ENOMEM));
   ns.addConstant("ENOMSG", new QoreBigIntNode(ENOMSG));
   ns.addConstant("ENOPROTOOPT", new QoreBigIntNode(ENOPROTOOPT));
   ns.addConstant("ENOSPC", new QoreBigIntNode(ENOSPC));
   ns.addConstant("ENOSR", new QoreBigIntNode(ENOSR));
   ns.addConstant("ENOSTR", new QoreBigIntNode(ENOSTR));
   ns.addConstant("ENOSYS", new QoreBigIntNode(ENOSYS));
   ns.addConstant("ENOTBLK", new QoreBigIntNode(ENOTBLK));
   ns.addConstant("ENOTCONN", new QoreBigIntNode(ENOTCONN));
   ns.addConstant("ENOTDIR", new QoreBigIntNode(ENOTDIR));
   ns.addConstant("ENOTEMPTY", new QoreBigIntNode(ENOTEMPTY));
   ns.addConstant("ENOTNAM", new QoreBigIntNode(ENOTNAM));
   ns.addConstant("ENOTSOCK", new QoreBigIntNode(ENOTSOCK));
   ns.addConstant("ENOTTY", new QoreBigIntNode(ENOTTY));
   ns.addConstant("ENXIO", new QoreBigIntNode(ENXIO));
   ns.addConstant("EOPNOTSUPP", new QoreBigIntNode(EOPNOTSUPP));
   ns.addConstant("EOVERFLOW", new QoreBigIntNode(EOVERFLOW));
   ns.addConstant("EPERM", new QoreBigIntNode(EPERM));
   ns.addConstant("EPFNOSUPPORT", new QoreBigIntNode(EPFNOSUPPORT));
   ns.addConstant("EPIPE", new QoreBigIntNode(EPIPE));
   ns.addConstant("EPROTO", new QoreBigIntNode(EPROTO));
   ns.addConstant("EPROTONOSUPPORT", new QoreBigIntNode(EPROTONOSUPPORT));
   ns.addConstant("EPROTOTYPE", new QoreBigIntNode(EPROTOTYPE));
   ns.addConstant("ERANGE", new QoreBigIntNode(ERANGE));
   ns.addConstant("EREMOTE", new QoreBigIntNode(EREMOTE));
   ns.addConstant("EROFS", new QoreBigIntNode(EROFS));
   ns.addConstant("ESHUTDOWN", new QoreBigIntNode(ESHUTDOWN));
   ns.addConstant("ESOCKTNOSUPPORT", new QoreBigIntNode(ESOCKTNOSUPPORT));
   ns.addConstant("ESRCH", new QoreBigIntNode(ESRCH));
   ns.addConstant("ESTALE", new QoreBigIntNode(ESTALE));
   ns.addConstant("ETIME", new QoreBigIntNode(ETIME));
   ns.addConstant("ETIMEDOUT", new QoreBigIntNode(ETIMEDOUT));
   ns.addConstant("ETOOMANYREFS", new QoreBigIntNode(ETOOMANYREFS));
   ns.addConstant("ETXTBSY", new QoreBigIntNode(ETXTBSY));
   ns.addConstant("EUSERS", new QoreBigIntNode(EUSERS));
   ns.addConstant("EWOULDBLOCK", new QoreBigIntNode(EWOULDBLOCK));
   ns.addConstant("EXDEV", new QoreBigIntNode(EXDEV));

}
