/* -*- mode: c++; indent-tabs-mode: nil -*- */
/*
  qc_qore.qpp

  Qore Programming Language

  Copyright 2003 - 2013 David Nichols

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.

  You should have received a copy of the GNU Lesser General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

#include <qore/Qore.h>
#include <qore/intern/QC_File.h>

#ifdef WORDS_BIGENDIAN
#define Q_MACHINE_MSB 1
#else
#define Q_MACHINE_MSB 0
#endif

DLLLOCAL void init_qore_constants(QoreNamespace& ns) {
# 34 "qc_qore.qpp"
# 41 "qc_qore.qpp"
# 44 "qc_qore.qpp"
# 47 "qc_qore.qpp"
# 50 "qc_qore.qpp"
# 53 "qc_qore.qpp"
# 56 "qc_qore.qpp"
# 59 "qc_qore.qpp"
# 62 "qc_qore.qpp"
# 65 "qc_qore.qpp"
# 68 "qc_qore.qpp"
# 71 "qc_qore.qpp"
# 74 "qc_qore.qpp"
   ns.addConstant("NT_BINARY", new QoreBigIntNode(NT_BINARY));
   ns.addConstant("NT_BOOLEAN", new QoreBigIntNode(NT_BOOLEAN));
   ns.addConstant("NT_CALLREF", new QoreBigIntNode(NT_FUNCREF));
   ns.addConstant("NT_CLOSURE", new QoreBigIntNode(NT_RUNTIME_CLOSURE));
   ns.addConstant("NT_DATE", new QoreBigIntNode(NT_DATE));
   ns.addConstant("NT_FLOAT", new QoreBigIntNode(NT_FLOAT));
   ns.addConstant("NT_HASH", new QoreBigIntNode(NT_HASH));
   ns.addConstant("NT_INT", new QoreBigIntNode(NT_INT));
   ns.addConstant("NT_LIST", new QoreBigIntNode(NT_LIST));
   ns.addConstant("NT_NOTHING", new QoreBigIntNode(NT_NOTHING));
   ns.addConstant("NT_NULL", new QoreBigIntNode(NT_NULL));
   ns.addConstant("NT_NUMBER", new QoreBigIntNode(NT_NUMBER));
   ns.addConstant("NT_OBJECT", new QoreBigIntNode(NT_OBJECT));
   ns.addConstant("NT_STRING", new QoreBigIntNode(NT_STRING));
# 81 "qc_qore.qpp"
# 104 "qc_qore.qpp"
   QoreHashNode* hash_TypeCodeMap = new QoreHashNode;
   hash_TypeCodeMap->setKeyValue("0", new QoreStringNode("nothing"), 0);
   hash_TypeCodeMap->setKeyValue("1", new QoreStringNode("integer"), 0);
   hash_TypeCodeMap->setKeyValue("2", new QoreStringNode("float"), 0);
   hash_TypeCodeMap->setKeyValue("3", new QoreStringNode("string"), 0);
   hash_TypeCodeMap->setKeyValue("4", new QoreStringNode("date"), 0);
   hash_TypeCodeMap->setKeyValue("5", new QoreStringNode("bool"), 0);
   hash_TypeCodeMap->setKeyValue("6", new QoreStringNode("NULL"), 0);
   hash_TypeCodeMap->setKeyValue("7", new QoreStringNode("binary"), 0);
   hash_TypeCodeMap->setKeyValue("8", new QoreStringNode("list"), 0);
   hash_TypeCodeMap->setKeyValue("9", new QoreStringNode("hash"), 0);
   hash_TypeCodeMap->setKeyValue("10", new QoreStringNode("object"), 0);
   hash_TypeCodeMap->setKeyValue("11", new QoreStringNode("number"), 0);
   hash_TypeCodeMap->setKeyValue("29", new QoreStringNode("call reference"), 0);
   hash_TypeCodeMap->setKeyValue("32", new QoreStringNode("closure"), 0);

   ns.addConstant("TypeCodeMap", hash_TypeCodeMap);
   QoreHashNode* hash_TypeNameMap = new QoreHashNode;
   hash_TypeNameMap->setKeyValue("nothing", new QoreBigIntNode(NT_NOTHING), 0);
   hash_TypeNameMap->setKeyValue("integer", new QoreBigIntNode(NT_INT), 0);
   hash_TypeNameMap->setKeyValue("float", new QoreBigIntNode(NT_FLOAT), 0);
   hash_TypeNameMap->setKeyValue("number", new QoreBigIntNode(NT_NUMBER), 0);
   hash_TypeNameMap->setKeyValue("string", new QoreBigIntNode(NT_STRING), 0);
   hash_TypeNameMap->setKeyValue("date", new QoreBigIntNode(NT_DATE), 0);
   hash_TypeNameMap->setKeyValue("bool", new QoreBigIntNode(NT_BOOLEAN), 0);
   hash_TypeNameMap->setKeyValue("NULL", new QoreBigIntNode(NT_NULL), 0);
   hash_TypeNameMap->setKeyValue("binary", new QoreBigIntNode(NT_BINARY), 0);
   hash_TypeNameMap->setKeyValue("list", new QoreBigIntNode(NT_LIST), 0);
   hash_TypeNameMap->setKeyValue("hash", new QoreBigIntNode(NT_HASH), 0);
   hash_TypeNameMap->setKeyValue("object", new QoreBigIntNode(NT_OBJECT), 0);
   hash_TypeNameMap->setKeyValue("call reference", new QoreBigIntNode(NT_FUNCREF), 0);
   hash_TypeNameMap->setKeyValue("closure", new QoreBigIntNode(NT_RUNTIME_CLOSURE), 0);

   ns.addConstant("TypeNameMap", hash_TypeNameMap);
# 123 "qc_qore.qpp"
   ns.addConstant("False", get_bool_node(false));
   ns.addConstant("True", get_bool_node(true));
# 133 "qc_qore.qpp"
   ns.addConstant("NOTHING", (&Nothing));
   ns.addConstant("NULL", (&Null));
# 143 "qc_qore.qpp"
   ns.addConstant("ET_System", new QoreStringNode("System"));
   ns.addConstant("ET_User", new QoreStringNode("User"));
# 153 "qc_qore.qpp"
# 159 "qc_qore.qpp"
# 162 "qc_qore.qpp"
   ns.addConstant("CT_Builtin", new QoreBigIntNode(CT_BUILTIN));
   ns.addConstant("CT_NewThread", new QoreBigIntNode(CT_NEWTHREAD));
   ns.addConstant("CT_Rethrow", new QoreBigIntNode(CT_RETHROW));
   ns.addConstant("CT_User", new QoreBigIntNode(CT_USER));
# 169 "qc_qore.qpp"
# 175 "qc_qore.qpp"
# 178 "qc_qore.qpp"
# 181 "qc_qore.qpp"
# 184 "qc_qore.qpp"
# 187 "qc_qore.qpp"
# 190 "qc_qore.qpp"
# 193 "qc_qore.qpp"
# 196 "qc_qore.qpp"
# 199 "qc_qore.qpp"
# 202 "qc_qore.qpp"
   ns.addConstant("Build", (new QoreBigIntNode(qore_build_number)));
   ns.addConstant("BuildHost", (new QoreStringNode(qore_build_host)));
   ns.addConstant("CFLAGS", (new QoreStringNode(qore_cflags)));
   ns.addConstant("Compiler", (new QoreStringNode(qore_cplusplus_compiler)));
   ns.addConstant("LDFLAGS", (new QoreStringNode(qore_ldflags)));
   ns.addConstant("MACHINE_MSB", get_bool_node(Q_MACHINE_MSB));
   ns.addConstant("PlatformCPU", (new QoreStringNode(TARGET_ARCH)));
   ns.addConstant("PlatformOS", (new QoreStringNode(TARGET_OS)));
   ns.addConstant("VersionMajor", (new QoreBigIntNode(qore_version_major)));
   ns.addConstant("VersionMinor", (new QoreBigIntNode(qore_version_minor)));
   ns.addConstant("VersionString", (new QoreStringNode(qore_version_string)));
   ns.addConstant("VersionSub", (new QoreBigIntNode(qore_version_sub)));
# 209 "qc_qore.qpp"
# 215 "qc_qore.qpp"
# 218 "qc_qore.qpp"
   ns.addConstant("SOURCE_FILE", new QoreBigIntNode(QORE_SOURCE_FILE));
   ns.addConstant("SOURCE_FTPCLIENT", new QoreBigIntNode(QORE_SOURCE_FTPCLIENT));
   ns.addConstant("SOURCE_HTTPCLIENT", new QoreBigIntNode(QORE_SOURCE_HTTPCLIENT));
   ns.addConstant("SOURCE_SOCKET", new QoreBigIntNode(QORE_SOURCE_SOCKET));
# 225 "qc_qore.qpp"
# 236 "qc_qore.qpp"
   QoreHashNode* hash_EVENT_MAP = new QoreHashNode;
   hash_EVENT_MAP->setKeyValue("1", new QoreStringNode("PACKET_READ"), 0);
   hash_EVENT_MAP->setKeyValue("2", new QoreStringNode("PACKET_SENT"), 0);
   hash_EVENT_MAP->setKeyValue("3", new QoreStringNode("HTTP_CONTENT_LENGTH"), 0);
   hash_EVENT_MAP->setKeyValue("4", new QoreStringNode("HTTP_CHUNKED_START"), 0);
   hash_EVENT_MAP->setKeyValue("5", new QoreStringNode("HTTP_CHUNKED_END"), 0);
   hash_EVENT_MAP->setKeyValue("6", new QoreStringNode("HTTP_REDIRECT"), 0);
   hash_EVENT_MAP->setKeyValue("7", new QoreStringNode("CHANNEL_CLOSED"), 0);
   hash_EVENT_MAP->setKeyValue("8", new QoreStringNode("DELETED"), 0);
   hash_EVENT_MAP->setKeyValue("9", new QoreStringNode("FTP_SEND_MESSAGE"), 0);
   hash_EVENT_MAP->setKeyValue("10", new QoreStringNode("FTP_MESSAGE_RECEIVED"), 0);
   hash_EVENT_MAP->setKeyValue("11", new QoreStringNode("HOSTNAME_LOOKUP"), 0);
   hash_EVENT_MAP->setKeyValue("12", new QoreStringNode("HOSTNAME_RESOLVED"), 0);
   hash_EVENT_MAP->setKeyValue("13", new QoreStringNode("HTTP_SEND_MESSAGE"), 0);
   hash_EVENT_MAP->setKeyValue("14", new QoreStringNode("HTTP_MESSAGE_RECEIVED"), 0);
   hash_EVENT_MAP->setKeyValue("15", new QoreStringNode("HTTP_FOOTERS_RECEIVED"), 0);
   hash_EVENT_MAP->setKeyValue("16", new QoreStringNode("HTTP_CHUNKED_DATA_RECEIVED"), 0);
   hash_EVENT_MAP->setKeyValue("17", new QoreStringNode("HTTP_CHUNK_SIZE"), 0);
   hash_EVENT_MAP->setKeyValue("18", new QoreStringNode("CONNECTING"), 0);
   hash_EVENT_MAP->setKeyValue("19", new QoreStringNode("CONNECTED"), 0);
   hash_EVENT_MAP->setKeyValue("20", new QoreStringNode("START_SSL"), 0);
   hash_EVENT_MAP->setKeyValue("21", new QoreStringNode("SSL_ESTABLISHED"), 0);
   hash_EVENT_MAP->setKeyValue("22", new QoreStringNode("OPEN_FILE"), 0);
   hash_EVENT_MAP->setKeyValue("23", new QoreStringNode("FILE_OPENED"), 0);
   hash_EVENT_MAP->setKeyValue("24", new QoreStringNode("DATA_READ"), 0);
   hash_EVENT_MAP->setKeyValue("25", new QoreStringNode("DATA_WRITTEN"), 0);

   ns.addConstant("EVENT_MAP", hash_EVENT_MAP);
   QoreHashNode* hash_EVENT_SOURCE_MAP = new QoreHashNode;
   hash_EVENT_SOURCE_MAP->setKeyValue("1", new QoreStringNode("SOCKET"), 0);
   hash_EVENT_SOURCE_MAP->setKeyValue("2", new QoreStringNode("HTTPCLIENT"), 0);
   hash_EVENT_SOURCE_MAP->setKeyValue("3", new QoreStringNode("FTPCLIENT"), 0);
   hash_EVENT_SOURCE_MAP->setKeyValue("4", new QoreStringNode("FILE"), 0);

   ns.addConstant("EVENT_SOURCE_MAP", hash_EVENT_SOURCE_MAP);
# 266 "qc_qore.qpp"
# 272 "qc_qore.qpp"
# 275 "qc_qore.qpp"
# 278 "qc_qore.qpp"
# 281 "qc_qore.qpp"
# 284 "qc_qore.qpp"
# 287 "qc_qore.qpp"
# 290 "qc_qore.qpp"
# 293 "qc_qore.qpp"
# 296 "qc_qore.qpp"
# 299 "qc_qore.qpp"
# 302 "qc_qore.qpp"
# 305 "qc_qore.qpp"
# 308 "qc_qore.qpp"
# 311 "qc_qore.qpp"
# 314 "qc_qore.qpp"
# 317 "qc_qore.qpp"
# 320 "qc_qore.qpp"
# 323 "qc_qore.qpp"
# 326 "qc_qore.qpp"
# 329 "qc_qore.qpp"
# 332 "qc_qore.qpp"
# 335 "qc_qore.qpp"
# 338 "qc_qore.qpp"
   ns.addConstant("EVENT_CHANNEL_CLOSED", new QoreBigIntNode(QORE_EVENT_CHANNEL_CLOSED));
   ns.addConstant("EVENT_CONNECTED", new QoreBigIntNode(QORE_EVENT_CONNECTED));
   ns.addConstant("EVENT_CONNECTING", new QoreBigIntNode(QORE_EVENT_CONNECTING));
   ns.addConstant("EVENT_DATA_READ", new QoreBigIntNode(QORE_EVENT_DATA_READ));
   ns.addConstant("EVENT_DATA_WRITTEN", new QoreBigIntNode(QORE_EVENT_DATA_WRITTEN));
   ns.addConstant("EVENT_DELETED", new QoreBigIntNode(QORE_EVENT_DELETED));
   ns.addConstant("EVENT_FILE_OPENED", new QoreBigIntNode(QORE_EVENT_FILE_OPENED));
   ns.addConstant("EVENT_FTP_MESSAGE_RECEIVED", new QoreBigIntNode(QORE_EVENT_FTP_MESSAGE_RECEIVED));
   ns.addConstant("EVENT_FTP_SEND_MESSAGE", new QoreBigIntNode(QORE_EVENT_FTP_SEND_MESSAGE));
   ns.addConstant("EVENT_HOSTNAME_LOOKUP", new QoreBigIntNode(QORE_EVENT_HOSTNAME_LOOKUP));
   ns.addConstant("EVENT_HOSTNAME_RESOLVED", new QoreBigIntNode(QORE_EVENT_HOSTNAME_RESOLVED));
   ns.addConstant("EVENT_HTTP_CHUNKED_DATA_RECEIVED", new QoreBigIntNode(QORE_EVENT_HTTP_CHUNKED_DATA_RECEIVED));
   ns.addConstant("EVENT_HTTP_CHUNKED_END", new QoreBigIntNode(QORE_EVENT_HTTP_CHUNKED_END));
   ns.addConstant("EVENT_HTTP_CHUNKED_START", new QoreBigIntNode(QORE_EVENT_HTTP_CHUNKED_START));
   ns.addConstant("EVENT_HTTP_CHUNK_SIZE", new QoreBigIntNode(QORE_EVENT_HTTP_CHUNK_SIZE));
   ns.addConstant("EVENT_HTTP_CONTENT_LENGTH", new QoreBigIntNode(QORE_EVENT_HTTP_CONTENT_LENGTH));
   ns.addConstant("EVENT_HTTP_FOOTERS_RECEIVED", new QoreBigIntNode(QORE_EVENT_HTTP_FOOTERS_RECEIVED));
   ns.addConstant("EVENT_HTTP_MESSAGE_RECEIVED", new QoreBigIntNode(QORE_EVENT_HTTP_MESSAGE_RECEIVED));
   ns.addConstant("EVENT_HTTP_REDIRECT", new QoreBigIntNode(QORE_EVENT_HTTP_REDIRECT));
   ns.addConstant("EVENT_HTTP_SEND_MESSAGE", new QoreBigIntNode(QORE_EVENT_HTTP_SEND_MESSAGE));
   ns.addConstant("EVENT_OPEN_FILE", new QoreBigIntNode(QORE_EVENT_OPEN_FILE));
   ns.addConstant("EVENT_PACKET_READ", new QoreBigIntNode(QORE_EVENT_PACKET_READ));
   ns.addConstant("EVENT_PACKET_SENT", new QoreBigIntNode(QORE_EVENT_PACKET_SENT));
   ns.addConstant("EVENT_SSL_ESTABLISHED", new QoreBigIntNode(QORE_EVENT_SSL_ESTABLISHED));
   ns.addConstant("EVENT_START_SSL", new QoreBigIntNode(QORE_EVENT_START_SSL));
# 345 "qc_qore.qpp"
# 354 "qc_qore.qpp"
   ns.addConstant("stderr", (QC_FILE->execSystemConstructor(2)));
   ns.addConstant("stdin", (QC_FILE->execSystemConstructor(0)));
   ns.addConstant("stdout", (QC_FILE->execSystemConstructor(1)));

}
